"
COPYRIGHT (c) 1996 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

DeviceWorkstation subclass:#WinWorkstation
	instanceVariableNames:'blackpixel whitepixel
		listOfFonts rootWin rootDC
		buttonsPressed eventRootX eventRootY eventTrace
		dispatchingExpose eventBuffer
		usingSystemPalette'
	classVariableNames:'RawKeysymTranslation'
	poolDictionaries:''
	category:'Interface-Graphics'
!

!WinWorkstation primitiveDefinitions!
%{

# undef INT
# define INT WIN_INT
# undef Array
# define Array WIN_Array
# undef Number
# define Number WIN_Number
# undef Method
# define Method WIN_Method
# undef Point
# define Point WIN_Point
# undef Rectangle
# define Rectangle WIN_Rectangle
# undef True
# define True WIN_True
# undef False
# define False WIN_False

# undef xxCONTEXT
# define xxCONTEXT        WIN_CONTEXT
# undef _xxCONTEXT
# define _xxCONTEXT       _WIN_CONTEXT



#include <stdio.h>
/* #include <malloc.h> */
/* #include <math.h> */
/* #include <string.h> */

#include <h/stdarg.h>

/* #include <h/windows.h> */

#  include <h/windef.h>
#  include <h/winbase.h>
#  include <h/wingdi.h>
#  include <h/winuser.h>


#   ifdef __DEF_Array
#    undef Array
#    define Array __DEF_Array
#   endif
#   ifdef __DEF_Number
#    undef Number
#    define Number __DEF_Number
#   endif
#   ifdef __DEF_Method
#    undef Method
#    define Method __DEF_Method
#   endif
#   ifdef __DEF_Point
#    undef Point
#    define Point __DEF_Point
#   endif

/*
 * some defines - tired of typing ...
 */
#define _HANDLEVal(o)        (HANDLE)(__MKCP(o))
#define _HDCVal(o)           (HDC)(__MKCP(o))
#define _HWNDVal(o)          (HWND)(__MKCP(o))
#define _HPALETTEVal(o)      (HPALETTE)(__MKCP(o))
#define _HCURSORVal(o)       (HCURSOR)(__MKCP(o))
#define _HGDIOBJVal(o)       (HGDIOBJ)(__MKCP(o))
#define _LOGPALETTEVal(o)    (LOGPALETTE *)(__MKCP(o))
#define _COLORREFVal(o)      (COLORREF)(__MKCP(o))
#define _HPEN(o)             (HPEN)(__MKCP(o))
#define _HBRUSH(o)           (HBRUSH)(__MKCP(o))

#define __rootDC             _HDCVal(__INST(rootDC))
#define ISCONNECTED          (__INST(rootDC) != nil)

/*
 * some synthetic values
 */
# define Button1MotionMask      1
# define Button2MotionMask      2
# define Button3MotionMask      4
# define ControlMask            8
# define ShiftMask              16
# define Mod1Mask               32
# define Mod2Mask               64

# define WhitePixel     RGB(0xFF, 0xFF, 0xFF)
# define BlackPixel     RGB(0, 0, 0)

# define DPRINTF(x)     	printf x
# define EVENT_PRINTF(x)     	printf x

# define _C_ARROW	1
# define _C_CROSS	2
# define _C_IBEAM	3
# define _C_ICON	4
# define _C_NO		5
# define _C_SIZE	6
# define _C_SIZEALL	7
# define _C_SIZENESW	8
# define _C_SIZENS	9
# define _C_SIZENWSE	10
# define _C_UPARROW	11
# define _C_WAIT	12

static HCURSOR H_C_ARROW = (HCURSOR)0;
static HCURSOR H_C_CROSS = (HCURSOR)0;
static HCURSOR H_C_IBEAM = (HCURSOR)0;
static HCURSOR H_C_ICON = (HCURSOR)0;
static HCURSOR H_C_NO = (HCURSOR)0;
static HCURSOR H_C_SIZE = (HCURSOR)0;
static HCURSOR H_C_SIZEALL = (HCURSOR)0;
static HCURSOR H_C_SIZENESW = (HCURSOR)0;
static HCURSOR H_C_SIZENS = (HCURSOR)0;
static HCURSOR H_C_SIZENWSE = (HCURSOR)0;
static HCURSOR H_C_UPARROW = (HCURSOR)0;
static HCURSOR H_C_WAIT = (HCURSOR)0;

%}
! !

!WinWorkstation primitiveVariables!
%{

static HANDLE hInstance = (HANDLE)0, 
	  hPrevInstance = (HANDLE)0;
static int firstInstance = 1;
static char *app_name = "ST/X";
static int __debug__ = 0;

static int __inCreate = 0;
static int create_topView;
static int create_minWidth;
static int create_maxWidth;
static int create_minHeight;
static int create_maxHeight;


%}
! !

!WinWorkstation primitiveFunctions!

%{

static
winEventProcessing(hWnd, message, wParam, lParam, pDefault)
    HWND hWnd;                /* window handle                   */
    UINT message;             /* type of message                 */
    UINT wParam;              /* additional information          */
    LONG lParam;              /* additional information          */
    int *pDefault;
{
    LPMINMAXINFO lpmmi;

    EVENT_PRINTF(("winEvent hWin=0x%x message=0x%x wP=0x%x lP=0x%x\n", 
                     	hWnd, message, wParam, lParam));

    if (__inCreate) {
	EVENT_PRINTF(("in create\n"));

	switch (message) {
	    case WM_GETMINMAXINFO:
		if (create_topView) {
                    lpmmi = (LPMINMAXINFO) lParam;

                    lpmmi->ptMaxSize.x = create_maxWidth;
                    lpmmi->ptMaxSize.y = create_maxHeight;
                    lpmmi->ptMaxTrackSize.x = create_maxWidth;
                    lpmmi->ptMaxTrackSize.y = create_maxHeight;
                    lpmmi->ptMinTrackSize.x = create_minWidth;
                    lpmmi->ptMinTrackSize.y = create_minHeight;
                    DPRINTF(("WM_GETMINMAXINFO handle=%x return min: %d/%d max: %d/%d\n", 
                                    hWnd,
                                    create_minWidth, create_minHeight,
                                    create_maxWidth, create_maxHeight));
		    *pDefault = 0;
		    return 1;
	        }
		break;
	}
    }

    switch (message) {
        case WM_GETTEXT:
            DPRINTF(("WM_GETTEXT - no window\n"));
            break;

        case WM_GETTEXTLENGTH:
            DPRINTF(("WM_GETTEXTLENGTH - no window\n"));
            break;

        case WM_NCCREATE:
            DPRINTF(("WM_NCCREATE - no window\n"));
            break;

        case WM_GETMINMAXINFO:
            DPRINTF(("WM_GETMINMAXINFO - no window\n"));
            break;

        case WM_NCHITTEST:
            DPRINTF(("WM_NCHITTEST - no window\n"));
            break;

        case WM_NCMOUSEMOVE:
            DPRINTF(("WM_NCMOUSEMOVE - no window\n"));
            break;

        case WM_PARENTNOTIFY:
            DPRINTF(("WM_PARENTNOTIFY - no window\n"));
            break;

        case WM_SETCURSOR:
            DPRINTF(("WM_SETCURSOR - no window\n"));
            break;

        case WM_NCLBUTTONDOWN:
            DPRINTF(("WM_NCLBUTTONDOWN - no window\n"));
            break;

        case 0x88:
            DPRINTF(("0x88 (undoc) - no window\n"));
            break;

        case 0x231:
            DPRINTF(("0x231 (undoc) - no window\n"));
            break;

        case 0x232:
            DPRINTF(("0x232 (undoc) - no window\n"));
            break;

        case WM_SIZE:
            DPRINTF(("WM_SIZE - no window\n"));
            break;

        case WM_CREATE:
            DPRINTF(("WM_CREATE - no window\n"));
            break;

        case WM_PAINT:
            DPRINTF(("WM_PAINT - no window\n"));
            break;

        case WM_ERASEBKGND:
            DPRINTF(("WM_ERASEBKGND - no window\n"));
            break;

        case WM_NCCALCSIZE:
            DPRINTF(("WM_NCCALCSIZE - no window\n"));
            break;

        case WM_NCPAINT:
            DPRINTF(("WM_NCPAINT - no window\n"));
            break;

        case WM_KEYDOWN:
            DPRINTF(("WM_KEYDOWN - no window\n"));
            break;

        case WM_KEYUP:
            DPRINTF(("WM_KEYUP - no window\n"));
            break;

        case WM_SYSCHAR:
            DPRINTF(("WM_SYSCHAR - no window\n"));
            break;

        case WM_CHAR:
            DPRINTF(("WM_CHAR - no window\n"));
            break;

        case WM_SYSCOMMAND:
            DPRINTF(("WM_SYSCOMMAND - no window\n"));
            break;

        case WM_INITMENU:
            DPRINTF(("WM_INITMENU - no window\n"));
            break;

        case WM_INITMENUPOPUP:
            DPRINTF(("WM_INITMENUPOPUP - no window\n"));
            break;

        case WM_ENTERIDLE:
            DPRINTF(("WM_ENTERIDLE - no window\n"));
            break;

        case WM_ENTERMENULOOP:
            DPRINTF(("WM_ENTERMENULOOP - no window\n"));
            break;

        case WM_EXITMENULOOP:
            DPRINTF(("WM_EXITMENULOOP - no window\n"));
            break;

        case WM_MENUSELECT:
            DPRINTF(("WM_MENUSELECT - no window\n"));
            break;

        case WM_QUIT:
            DPRINTF(("WM_QUIT - no window\n"));
            break;

        case WM_CLOSE:
            DPRINTF(("WM_CLOSE - no window\n"));
            break;

        case WM_DESTROY:
            DPRINTF(("WM_DESTROY - no window\n"));
            break;

        case WM_NCDESTROY:
            DPRINTF(("WM_NCDESTROY - no window\n"));
            break;

        case WM_QUERYNEWPALETTE:
            DPRINTF(("WM_QUERYNEWPALETTE - no window\n"));
            break;

        case WM_PALETTECHANGED:
            DPRINTF(("WM_PALETTECHANGED - no window\n"));
            break;

        case WM_NCACTIVATE:
            DPRINTF(("WM_NCACTIVATE - no window\n"));
            break;

        case WM_ACTIVATE:
            DPRINTF(("WM_ACTIVATE %s - no window\n", LOWORD(wParam) ? "active" : "inactive"));
            break;

        case WM_ACTIVATEAPP:
            DPRINTF(("WM_ACTIVATEAPP %s - no window\n", wParam ? "active" : "inactive"));
            break;

        case WM_WINDOWPOSCHANGED:
            DPRINTF(("WM_WINDOWPOSCHANGED - no window\n"));
            break;

        case WM_MOVE:
            DPRINTF(("WM_MOVE - no window\n"));
            break;

        case WM_KILLFOCUS:
            DPRINTF(("WM_KILLFOCUS - no window\n"));
            break;

        case WM_SETFOCUS:
            DPRINTF(("WM_SETFOCUS - no window\n"));
            break;

        case WM_SYSKEYUP:
            DPRINTF(("WM_SYSKEYUP - no window\n"));
            break;

        case WM_PAINTICON:
            DPRINTF(("WM_PAINTICON - no window\n"));
            break;

        case WM_ICONERASEBKGND:
            DPRINTF(("WM_ICONERASEBKGND - no window\n"));
            break;

        case WM_WINDOWPOSCHANGING:
            DPRINTF(("WM_WINDOWPOSCHANGING - no window\n"));
            break;

        case WM_SHOWWINDOW:
            DPRINTF(("WM_SHOWWINDOW - no window\n"));
            break;

	case WM_LBUTTONDOWN:
	case WM_LBUTTONDBLCLK:
	    DPRINTF(("WM_LBUTTONDOWN / DCLK\n"));
	    break;

	case WM_LBUTTONUP:
	    DPRINTF(("WM_LBUTTONUP\n"));
	    break;

	case WM_MBUTTONDOWN:
	case WM_MBUTTONDBLCLK:
	    DPRINTF(("WM_MBUTTONDOWN / DCLK\n"));
	    break;

	case WM_MBUTTONUP:
	    DPRINTF(("WM_MBUTTONUP\n"));
	    break;

        case WM_RBUTTONDOWN:
        case WM_RBUTTONDBLCLK:
            DPRINTF(("WM_RBUTTONDOWN / DCLK\n"));
	    break;

	case WM_RBUTTONUP:
	    DPRINTF(("WM_RBUTTONUP\n"));
	    break;

	case WM_MOUSEMOVE:
	    DPRINTF(("WM_MOUSEMOVE\n"));
	    break;

	case WM_MOUSEACTIVATE:
	    DPRINTF(("WM_MOUSEACTIVATE\n"));
	    break;

	case WM_QUERYOPEN:
	    DPRINTF(("WM_QUERYOPEN\n"));
	    break;

	case WM_QUERYENDSESSION:
	    DPRINTF(("WM_QUERYENDSESSION\n"));
	    break;

        default:
            DPRINTF(("type = %x no window\n", message));
            break;
    }

}

LONG APIENTRY
MainWndProc(hWnd, message, wParam, lParam) 
    HWND hWnd;                /* window handle                   */
    UINT message;             /* type of message                 */
    UINT wParam;              /* additional information          */
    LONG lParam;              /* additional information          */
{
    int wantDefault = 1;
    int retVal;

    DPRINTF((">> MainWndProc\n"));

    retVal = winEventProcessing(hWnd, message, wParam, lParam, &wantDefault);
    if (wantDefault) {
        DPRINTF(("call DefWindowProc\n"));
        retVal = DefWindowProc(hWnd, message, wParam, lParam);
    }
    DPRINTF(("<< MainWndProc\n"));
    return retVal;
}

%}
! !


!WinWorkstation  class methodsFor:'documentation'!

copyright
"
COPYRIGHT (c) 1996 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    See more documentation in my superclass, DeviceWorkstation.

    [author:]
	Claus Gittinger
"
! !

!WinWorkstation  class methodsFor:'initialization'!

initialize
    |d|

    super initialize.
! !

!WinWorkstation  class methodsFor:'error handling'!

debug:aBoolean
%{  /* NOCONTEXT */

    __debug__ = (aBoolean == true) ? 1 : 0;
%}
! !

!WinWorkstation  class methodsFor:'queries'!

platformName
    "ST-80 compatibility.
     Return a string describing the display systems platform."

    ^ 'WIN32'  

    "Modified: 26.5.1996 / 15:32:46 / cg"
! !

!WinWorkstation methodsFor:'accessing & queries'!

anyButtonMotionMask
    "return the state-mask for any button in motion events' state-field.
     This is the devices mask."

%{  /* NOCONTEXT */
    RETURN ( __MKSMALLINT(Button1MotionMask | Button2MotionMask | Button3MotionMask)); 
%}.
    ^ nil
!

blackpixel
    "return the colornumber of black"

    ^ blackpixel
!

button1MotionMask
    "return the state-mask for button1 in motion events' state-field.
     For backward compatibility."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(Button1MotionMask)); 
%}

    "
     Display button1MotionMask
    "
!

button2MotionMask
    "return the state-mask for button2 in motion events' state-field
     For backward compatibility."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(Button2MotionMask)); 
%}
!

button3MotionMask
    "return the state-mask for button3 in motion events' state-field
     For backward compatibility."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(Button3MotionMask)); 
%}
!

buttonMotionMask:aButton
    "return the state-mask for button1 in motion events state-field.
     This is the devices mask."

%{  /* NOCONTEXT */
    if (aButton == __MKSMALLINT(1)) {
	RETURN (__MKSMALLINT(Button1MotionMask));    
    }
    if (aButton == __MKSMALLINT(2)) {
	RETURN (__MKSMALLINT(Button2MotionMask));    
    }
    if (aButton == __MKSMALLINT(3)) {
	RETURN (__MKSMALLINT(Button3MotionMask));    
    }
%}.
    ^ nil
!

controlMask
    "return the state-mask for the CTRL modified in motion events' state-field."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(ControlMask));
%}
!

defaultEventMask
    "return a mask to enable some events by default."

%{  /* NOCONTEXT */
#ifdef XXX
    RETURN (__MKSMALLINT(ExposureMask | StructureNotifyMask |
			 KeyPressMask | KeyReleaseMask |
			 EnterWindowMask | LeaveWindowMask |
			 ButtonPressMask | ButtonMotionMask | ButtonReleaseMask ));
#endif
%}.
    ^ 0
!

displayFileDescriptor
    "return the displays fileNumber - for select"

%{  /* NOCONTEXT */
    RETURN (nil);
%}
!

displayName
    "return the X-connections display name.
     This is (currently) nil for the default display, 
     something like foo:0 for any other remote display.
     Future versions may return non-nil strings for the default display as well."

    ^ 'local'
!

protocolVersion
    "return the X-servers protocol version - should normally not be of
     any interest"

    ^ '1'

    "
     Display protocolVersion
    "
!

serverVendor
    "return the X-server vendor string - this should normally not be of
     any interest, but can be for special cases
     (to avoid bugs in certain implementations)"

    ^ 'microsoft'

    "
     Display serverVendor
    "
!

shiftMask
    "return the state-mask for the SHIFT modified in motion events' state-field."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(ShiftMask));
%}
!

translatePoint:aPoint from:windowId1 to:windowId2
    "given a point in window1, return the coordinate in window2.
     This expects a device coordinate (relative to the first views origin)
     in aPoint and returns a device coordinate relative to the 2nd views origin.
     - use to xlate points from a window to rootwindow"

    |x1 y1 x2 y2|

    x1 := x2 := aPoint x truncated.
    y1 := y2 := aPoint y truncated.
%{
    int xpos, ypos;
    HWND w1, w2;
    RECT srcRect, dstRect;

    if (__isExternalAddress(windowId1)
     && __isExternalAddress(windowId2)
     && __bothSmallInteger(x1, y1)) {
	w1 = _HWNDVal(windowId1);
	w2 = _HWNDVal(windowId2);

	GetWindowRect(w1, &srcRect);
	GetWindowRect(w2, &dstRect);

	xpos = dstRect.left - srcRect.left + __intVal(x1);
	ypos = dstRect.top - srcRect.top + __intVal(y1);

	x2 = __MKSMALLINT(xpos);
	y2 = __MKSMALLINT(ypos);
    }
%}.
    ^ (x2 @ y2)
!

vendorRelease
    "return the X-servers vendor release - should normally not be of
     any interest, but can be for special cases.
     (to avoid bugs in certain implementations)"

    ^ 1

    "
     Display vendorRelease
    "
!

whitepixel
    "return the colornumber of white"

    ^ whitepixel
! !

!WinWorkstation methodsFor:'accessing display capabilities'!

iconSizes
    "Get the preferred/supported icon sizes."

    |d|

    d := IdentityDictionary new.
    d at:#minWidth put:32.
    d at:#maxWidth put:32.
    d at:#widthStep put:1.
    d at:#minHeight put:32.
    d at:#maxHeight put:32.
    d at:#heightStep put:1.

    ^ OrderedCollection with:d

    "
     Display iconSizes
    "
!

supportsIconViews
    "return true, if this device supports views as icons.
     Only Xservers (currently) support this."

    ^ true

    "
     Display supportsIconViews 
    "

    "Modified: 10.6.1996 / 20:11:48 / cg"
    "Created: 10.6.1996 / 21:08:18 / cg"
! !

!WinWorkstation methodsFor:'bitmap/window creation'!

createBitmapFromArray:anArray width:w height:h
    |bitmapId|

    bitmapId := self primCreateBitmapFromArray:anArray width:w height:h.
    bitmapId isNil ifTrue:[
	self primitiveFailed
    ].
    ^ bitmapId
!

createBitmapWidth:w height:h
    "allocate a bitmap on the Xserver, the contents is undefined
     (i.e. random). Return a bitmap id or nil"

%{  /* NOCONTEXT */
%}.
    ^ nil
!

createPixmapWidth:w height:h depth:d
    "allocate a pixmap on the Xserver, the contents is undefined
     (i.e. random). Return a bitmap id or nil"

%{  /* NOCONTEXT */
%}.
    ^ nil
!

createWindowFor:aView left:xpos top:ypos width:wwidth height:wheight
    "will vanish - for compatibility with previous versions"

    ^ self 
	  createWindowFor:aView 
	  origin:(xpos @ ypos)
	  extent:(wwidth @ wheight)
	  minExtent:(aView minExtent)
	  maxExtent:(aView maxExtent)
	  borderWidth:(aView borderWidth)
	  subViewOf:(aView superView)
	  onTop:(aView isPopUpView)
	  inputOnly:(aView isInputOnly)
	  label:(aView label)
	  cursor:(aView cursor)
	  icon:(aView icon)
	  iconView:(aView iconView)

    "Modified: 1.6.1996 / 13:22:48 / cg"
!

createWindowFor:aView
		 origin:origin
		 extent:extent
		 minExtent:minExt 
		 maxExtent:maxExt
		 borderWidth:bWidth
		 subViewOf:wsuperView
		 onTop:wisPopUpView
		 inputOnly:winputOnly
		 label:wlabel
		 cursor:wcursor
		 icon:wicon
		 iconView:wiconView

    |xpos ypos wwidth wheight minWidth minHeight maxWidth maxHeight 
     bColorId wsuperViewId wcursorId wiconId windowId
     weventMask wiconViewId bitGravity viewGravity vBgColor
     vBgForm deepForm preferredVisual preferredDepth|

    displayId isNil ifTrue:[
	self primitiveFailed.
	^ nil
    ].

    origin notNil ifTrue:[
	xpos := origin x.
	ypos := origin y.
    ] ifFalse:[
	xpos := ypos := 0.
    ].
    extent notNil ifTrue:[
	wwidth := extent x.
	wheight := extent y.
    ] ifFalse:[
	wwidth := wheight := 100.
    ].
    minExt notNil ifTrue:[
	minWidth := minExt x.
	minHeight := minExt y
    ].
    maxExt notNil ifTrue:[
	maxWidth := maxExt x.
	maxHeight := maxExt y
    ].

    wsuperView notNil ifTrue:[
	wsuperViewId := wsuperView id
    ].
    wcursor isNil ifTrue:[
	'XWORKSTATION: cursor nil - defaulted' errorPrintNL
    ] ifFalse:[
	wcursorId := wcursor id
    ].

    wicon notNil ifTrue:[
	wiconId := wicon id
    ].
    wiconView notNil ifTrue:[
	wiconViewId := wiconView id
    ].
    weventMask := aView eventMask.

%{  /* STACK:16000 */
    extern void *__getHInstance(), *__getHPrevInstance();

    WNDCLASS wc;
    long bg, bd, bw;
    int winStyle;
    int width, height, x, y;
    int min_width, min_height;
    int max_width, max_height;
    HANDLE parentHandle;
    HANDLE newWinHandle;
    char *windowName = NULL;
    int isTopWindow = 0;

    bg = WhitePixel;
    bd = BlackPixel;

    if (firstInstance) {
	DPRINTF(("first create - registerClass\n"));

	hInstance = (HANDLE) __getHInstance();
	hPrevInstance = (HANDLE) __getHPrevInstance();

	wc.style = /* CS_HREDRAW | CS_VREDRAW | */ CS_OWNDC | CS_DBLCLKS;
	wc.lpfnWndProc = (WNDPROC) MainWndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);

	wc.hbrBackground = CreateSolidBrush (bg);

	wc.lpszMenuName =  NULL;
	wc.lpszClassName = app_name;

	if (!RegisterClass(&wc)) {
	    DPRINTF(("RegisterClass failed\n"));
/*            return NULL;     */
	}
	firstInstance = 0;
    }

    if (__bothSmallInteger(wwidth, wheight)) {
	width = __intVal(wwidth);
	height = __intVal(wheight);
    } else {
	width = height = 100;
    }

    if (__bothSmallInteger(xpos, ypos)) {
	x = __intVal(xpos);
	y = __intVal(ypos);
    } else {
	x = y = 0;
    }

    if (__bothSmallInteger(minWidth, minHeight)) {
	min_width = __intVal(minWidth);
	min_height = __intVal(minHeight);
    } else {
	min_width = min_height = 0;
    }

    if (__bothSmallInteger(maxWidth, maxHeight)) {
	max_width = __intVal(maxWidth);
	max_height = __intVal(maxHeight);
    } else {
	max_width = max_height = 10000;
    }
    winStyle = 0;

    if (__isSmallInteger(bWidth)) {
	bw = __intVal(bWidth);
	winStyle |= WS_BORDER;
    } else {
	bw = 0;
    }

    if (__isExternalAddress(wsuperViewId)) {
	/* a child window */
	parentHandle = _HANDLEVal(wsuperViewId);
	winStyle |= WS_CHILD | WS_CLIPCHILDREN | WS_CLIPSIBLINGS;
	DPRINTF(("parent handle=%x\n", parentHandle));

	create_topView = 0;
    } else {
	/* a top window */
	parentHandle = NULL;
	isTopWindow = 1;
	winStyle |= WS_CLIPCHILDREN;
	DPRINTF(("topview\n"));

	create_topView = 1;
	create_minWidth = min_width;
	create_maxWidth = max_width;
	create_minHeight = min_height;
	create_maxHeight = max_height;
    }

    if (wisPopUpView == true) {
	winStyle |= WS_POPUP;
    } else {
	winStyle |= WS_OVERLAPPEDWINDOW;
    }

    DPRINTF(("create ...\n"));

    __inCreate = 1;
    newWinHandle = CreateWindow(app_name, "",
				winStyle,
				x, y,
				width + (bw * 2), height + (bw * 2),
				parentHandle,
				NULL, hInstance, NULL);
    __inCreate = 0;

    DPRINTF(("handle = %x\n", newWinHandle));

    if (! newWinHandle) {
	RETURN ( nil );
    }

    /*
     * define its icon and name
     * (only makes sense for topWindows)
     */
    if (isTopWindow) {
	if (__isString(wlabel) || __isSymbol(wlabel)) {
	    windowName = (char *) __stringVal(wlabel);
    	    DPRINTF(("title = %s\n", windowName));
	    (void) SetWindowText(newWinHandle, windowName);
	}
    }

    windowId = __MKOBJ(newWinHandle);
    DPRINTF(("done - create\n"));
%}.
    self addKnownView:aView withId:windowId.
    ^ windowId
!

destroyGC:aGCId
    ^ self
!

destroyPixmap:aDrawableId
    self primitiveFailed
!

destroyView:aView withId:aWindowId
%{
    if (__isExternalAddress(aWindowId)) {
	HWND win = _HWNDVal(aWindowId);

	if (win) {
	    DestroyWindow(win);
	}
    }
%}.
    self removeKnownView:aView
!

gcFor:aDrawableId

%{  /* NOCONTEXT */
    HDC dc;

    if (__isExternalAddress(aDrawableId)) {
	dc = GetDC(_HWNDVal(aDrawableId));
	RETURN ( dc ? __MKOBJ(dc) : nil );
    }
%}.
    self primitiveFailed.
    ^ nil
!

primCreateBitmapFromArray:anArray width:w height:h

%{  /* UNLIMITEDSTACK */

    RETURN ( nil );
%}
!

rootWindowId
    "return the id of the root window.
     This is the window you see as background, 
     however, it may or may not be the real physical root window,
     since some window managers install a virtual root window on top
     of the real one. If this is the case, that views id is returned here."

    ^ rootWin
! !

!WinWorkstation methodsFor:'color stuff'!

colorRed:redVal green:greenVal blue:blueVal
    "allocate a color with rgb values (0..100) - return the color index (i.e. colorID).
     This method is obsoleted by #colorScaledRed:scaledGreen:scaledBlue:"

    |r g b|

    r := self percentToDeviceColorColorValue:redVal.
    g := self percentToDeviceColorColorValue:greenVal.
    b := self percentToDeviceColorColorValue:blueVal.
    ^ self colorScaledRed:r scaledGreen:g scaledBlue:b
!

colorScaledRed:r scaledGreen:g scaledBlue:b
    "allocate a color with rgb values (0..16rFF) - return the color index 
     (i.e. colorID)"
%{
    int id;

    if (__bothSmallInteger(r, g) 
     && __isSmallInteger(b)) {
	id = RGB ( (BYTE)(__intVal(r)),
		   (BYTE)(__intVal(g)),
		   (BYTE)(__intVal(b)));
	RETURN ( __MKSMALLINT(id) );
    }
%}.
    self primitiveFailed.
    ^ nil
!

freeColor:colorIndex
    "free a display color when its no longer needed"

    ^ self
!

getRGBFrom:index into:aBlock
    "get rgb components (0..100) of color in map at:index,
     and evaluate the 3-arg block, aBlock with them"

    |val|

    self getScaledRGBFrom:index into:[:r :g :b |
	val := aBlock 
		value:(r * 100.0 / 16rFF)
		value:(g * 100.0 / 16rFF)
		value:(b * 100.0 / 16rFF)
    ].
    ^ val
!

getRGBFromName:colorName into:aBlock
    "get rgb components (0..100) of color named colorName,
     and evaluate the 3-arg block, aBlock with them"
    |val|

    self getScaledRGBFromName:colorName into:[:r :g :b |
	val := aBlock 
		value:(r * 100.0 / 16rFF)
		value:(g * 100.0 / 16rFF)
		value:(b * 100.0 / 16rFF)
    ].
    ^ val
!

getScaledRGBFrom:index into:aBlock
    "get rgb components (0 .. 16rFFFF) of color in map at:index,
     and evaluate the 3-arg block, aBlock with them"

    |r g b|
%{
    int id = __intVal(index);

    if (__INST(usingSystemPalette) == true) {
	r = g = b = __MKSMALLINT(0);
    } else {
	r = __MKSMALLINT(id & 0xFF);
	g = __MKSMALLINT((id >> 8) & 0xFF);
	b = __MKSMALLINT((id >> 16) & 0xFF);
    }
%}.
    ^ aBlock value:r value:g value:b
!

percentToDeviceColorColorValue:aPercentage
    "given a color-component value in percent (0..100), return the corresponding
     WIN-component value (0..16rFF) as an integer"

%{  /* NOCONTEXT */

    if (__isSmallInteger(aPercentage)) {
	RETURN ( __MKSMALLINT(0xFF * __intVal(aPercentage) / 100) );
    }
    if (__isFloat(aPercentage)) {
	RETURN ( __MKSMALLINT(0xFF * (int)(__floatVal(aPercentage)) / 100) );
    }
%}.
    ^ (16rFF * aPercentage / 100) rounded
! !

!WinWorkstation methodsFor:'cursor stuff'!

createCursorShape:aShape
    "create a cursor given a shape-symbol"

    |number id|

    number := self shapeNumberFromSymbol:aShape.
%{
    HCURSOR newCursor;
    LPCTSTR cId;

    if (__isSmallInteger(number)) {
	cId = (LPCTSTR)(__intVal(number));
	newCursor = LoadCursor(NULL, cId);
	if (newCursor) {
	    if (cId == IDC_ARROW)
		H_C_ARROW = newCursor;
	    else if (cId == IDC_CROSS)
		H_C_CROSS = newCursor;
	    else if (cId == IDC_IBEAM)
		H_C_IBEAM = newCursor;
	    else if (cId == IDC_ICON)
		H_C_ICON = newCursor;
	    else if (cId == IDC_NO)
		H_C_NO = newCursor;
	    else if (cId == IDC_SIZE)
		H_C_SIZE = newCursor;
	    else if (cId == IDC_SIZEALL)
		H_C_SIZEALL = newCursor;
	    else if (cId == IDC_SIZENESW)
		H_C_SIZENESW = newCursor;
	    else if (cId == IDC_SIZENS)
		H_C_SIZENS = newCursor;
	    else if (cId == IDC_SIZENWSE)
		H_C_SIZENWSE = newCursor;
	    else if (cId == IDC_UPARROW)
		H_C_UPARROW = newCursor;
	    else if (cId == IDC_WAIT)
		H_C_WAIT = newCursor;
	
	    id = __MKOBJ(newCursor);
	}
    }
%}.
    ^ id
!

createCursorSourceForm:sourceBytes maskForm:maskBytes hotX:hx hotY:hy width:w height:h
    "create a cursor given 2 bitmaps (source, mask) and a hotspot"

    |id|

%{
    HCURSOR newCursor;

    if (__isByteArray(sourceBytes)
     && __isByteArray(maskBytes)
     && __bothSmallInteger(hx, hy)
     && __bothSmallInteger(w, h)) {

	newCursor = CreateCursor(hInstance,
				 __intVal(hx), __intVal(hy),
				 __intVal(w), __intVal(h),
				__ByteArrayInstPtr(maskBytes)->ba_element,
				__ByteArrayInstPtr(sourceBytes)->ba_element);
	if (newCursor) {
	    id = __MKOBJ(newCursor);
	}
    }
%}.
    ^ id
!

destroyCursor:aCursorId

%{  /* NOCONTEXT */

    if (ISCONNECTED) {
	if (__isExternalAddress(aCursorId)) {
	    HCURSOR curs = _HCURSORVal(aCursorId);

	    if (curs) {
		if ((curs != H_C_ARROW)
		 && (curs != H_C_CROSS)
		 && (curs != H_C_IBEAM)
		 && (curs != H_C_ICON)
		 && (curs != H_C_NO)
		 && (curs != H_C_SIZE)
		 && (curs != H_C_SIZEALL)
		 && (curs != H_C_SIZENESW)
		 && (curs != H_C_SIZENS)
		 && (curs != H_C_SIZENWSE)
		 && (curs != H_C_UPARROW)
		 && (curs != H_C_WAIT)) {
		    DestroyCursor(curs);
		}
	    }
	    RETURN ( self );
	}
    }
%}.
    self primitiveFailed
!

needDeviceFormsForCursor
    ^ false
!

shapeNumberFromSymbol:shape
    "given a shape-symbol, return the corresponding cursor-number,
     or nil if no such standard cursor exists."

    "this is pure Win-knowlegde - but you may easily add more"

%{  /* NOCONTEXT */
    if (shape == @symbol(upLeftArrow)) {
	RETURN ( __MKSMALLINT( (INT)IDC_ARROW));
    }
    if (shape == @symbol(upDownArrow)) {
	RETURN ( __MKSMALLINT( (INT)IDC_SIZENS));
    }
    if (shape == @symbol(leftRightArrow)) {
	RETURN ( __MKSMALLINT( (INT)IDC_SIZEWE));
    }
    if (shape == @symbol(text)) {
	RETURN ( __MKSMALLINT( (INT)IDC_IBEAM));
    }
    if (shape == @symbol(wait)) {
	RETURN ( __MKSMALLINT( (INT)IDC_WAIT));
    }
    if (shape == @symbol(crossHair)) {
	RETURN ( __MKSMALLINT( (INT)IDC_CROSS));
    }
    if (shape == @symbol(fourWay)) {
	RETURN ( __MKSMALLINT( (INT)IDC_SIZE));
    }
%}.
"/    ('WINWORKSTATION: invalid cursorShape:' , shape printString) infoPrintNL.
    ^  nil
! !

!WinWorkstation methodsFor:'drawing'!

copyFromId:sourceId x:srcX y:srcY gc:srcDCId to:destId x:dstX y:dstY gc:dstDCId
		width:w height:h 
    "do a bit-blt; copy bits from the rectangle defined by
     srcX/srcY and w/h from the sourceId drawable to the rectangle
     below dstX/dstY in the destId drawable. Trigger an error if any
     argument is not integer."

%{  /* NOCONTEXT */

    HDC srcDC, dstDC;

    if (__isExternalAddress(srcDCId)
     && __isExternalAddress(dstDCId)
     && __bothSmallInteger(w, h)
     && __bothSmallInteger(srcX, srcY)
     && __bothSmallInteger(dstX, dstY)) {
        
	srcDC = _HDCVal(srcDCId);
	dstDC = _HDCVal(dstDCId);
	BitBlt(dstDC, 
	       __intVal(dstX), __intVal(dstY),
	       __intVal(w), __intVal(h),
	       srcDC,
	       __intVal(srcX), __intVal(srcY),
	       SRCCOPY);
	RETURN ( self );
    }
%}.
    "badGC, bad sourceDrawableId or destDrawableID
     or any non integer coordinate"

    self primitiveFailed
!

copyPlaneFromId:sourceId x:srcX y:srcY gc:srcDCId to:destId x:dstX y:dstY gc:dstDCId
		width:w height:h 
    "do a bit-blt, but only copy the low-bit plane; 
     copy bits from the rectangle defined by
     srcX/srcY and w/h from the sourceId drawable to the rectangle
     below dstX/dstY in the destId drawable. Trigger an error if any
     argument is not integer."

    ^ self
	copyFromId:sourceId 
		 x:srcX y:srcY gc:srcDCId 
		to:destId x:dstX y:dstY gc:dstDCId
	     width:w height:h 
!

displayArcX:x y:y width:width height:height from:startAngle angle:angle in:aDrawableId with:aGCId
    "draw an arc. If any of x,y, w or h is not an integer, an error is triggered.
     The angles may be floats or integer - they are given in degrees."

%{  /* NOCONTEXT */

    int w, h, angle1, angle2;
    double f;

    if (__isSmallInteger(startAngle))
	angle1 = __intVal(startAngle) * 64;
    else if (__isFloat(startAngle)) {
	f = __floatVal(startAngle);
	angle1 = f * 64;
    }
    if (__isSmallInteger(angle))
	angle2 = __intVal(angle) * 64;
    else if (__isFloat(angle)) {
	f = __floatVal(angle);
	angle2 = f * 64;
    }
    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
	w = __intVal(width);
	h = __intVal(height);
	RETURN ( self );
    }
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

displayLineFromX:x0 y:y0 toX:x1 y:y1 in:aDrawableId with:aGCId
    "draw a line. If the coordinates are not integers, an error is triggered." 

%{  /* NOCONTEXT */
    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x0, y0)
     && __bothSmallInteger(x1, y1)) {
	RETURN ( self );
    }
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

displayPointX:x y:y in:aDrawableId with:aGCId
    "draw a point. If x/y are not integers, an error is triggered." 

%{  /* NOCONTEXT */
    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x, y)) {
	RETURN ( self );
    }
%}.
    "badGC, badDrawable or x/y not integer"
    self primitiveFailed
!

displayPolygon:aPolygon in:aDrawableId with:aGCId
    "draw a polygon, the argument aPolygon is a Collection of individual points, which
     define the polygon.
     If any coordinate is not integer, an error is triggered."

    |numberOfPoints newPoints|

    numberOfPoints := aPolygon size.
%{
    OBJ point, x, y;
    int i, num;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __isSmallInteger(numberOfPoints)) {
	num = __intVal(numberOfPoints);

	for (i=0; i<num; i++) {
	    point = __AT_(aPolygon COMMA_CON, __MKSMALLINT(i+1));
	    if (! __isPoint(point)) goto fail;
	    x = _point_X(point);
	    y = _point_Y(point);
	    if (! __bothSmallInteger(x, y))
		goto fail;
	}
	RETURN ( self );
    }
fail: ;
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

displayRectangleX:x y:y width:width height:height in:aDrawableId with:aGCId
    "draw a rectangle. If the coordinates are not integers, an error is triggered." 

%{  /* NOCONTEXT */
    int w, h;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
	w = __intVal(width);
	h = __intVal(height);
	/*
	 * need this check here: some servers simply dump core with bad args
	 */
	if ((w >= 0) && (h >= 0)) {
	}
	RETURN ( self );
    }
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

displayString:aString from:index1 to:index2 x:x y:y in:aDrawableId with:aGCId opaque:opaque 
    "draw a sub-string - if opaque is false, draw foreground only; otherwise, draw both
     foreground and background characters.
     If the coordinates are not integers, an error is triggered."

%{  /* NOCONTEXT */
#ifdef NOTDEF
    GC gc;
    Window win;
    unsigned char *cp;
    OBJ cls;
    int  i1, i2, l, n;
#   define NLOCALBUFFER 200
    XChar2b xlatebuffer[NLOCALBUFFER];
    int nInstBytes;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __isNonNilObject(aString)
     && __bothSmallInteger(index1, index2)
     && __bothSmallInteger(x, y)) {
	gc = _GCVal(aGCId);
	win = _WindowVal(aDrawableId);
	cls = __qClass(aString);

	i1 = __intVal(index1) - 1;
	if (i1 >= 0) {
	    i2 = __intVal(index2) - 1;
	    if (i2 < i1) {
		RETURN (self);
	    }

	    cp = _stringVal(aString);
	    l = i2 - i1 + 1;

	    if ((cls == @global(String)) || (cls == @global(Symbol))) {
		n = _stringSize(aString);
		if (i2 < n) {
		    cp += i1;
		    if (l > 1000) l = 1000;
		    if (opaque == true)
			XDrawImageString(myDpy, win, gc, __intVal(x), __intVal(y), (char *)cp, l);
		    else
			XDrawString(myDpy, win, gc, __intVal(x), __intVal(y), (char *)cp, l);
		    RETURN ( self );
		}
	    }

	    nInstBytes = __OBJS2BYTES__(__intVal(__ClassInstPtr(cls)->c_ninstvars));
	    cp += nInstBytes;

	    if (__isBytes(aString)) {
		n = __byteArraySize(aString) - nInstBytes - 1;

		if (i2 < n) {
		    cp += i1;
		    if (l > 1000) l = 1000;
		    if (opaque == true)
			XDrawImageString(myDpy, win, gc, __intVal(x), __intVal(y), (char *)cp, l);
		    else
			XDrawString(myDpy, win, gc, __intVal(x), __intVal(y), (char *)cp, l);
		    RETURN ( self );
		}
	    }

	    /* TWOBYTESTRINGS */
	    if (__isWords(aString)) {
		n = (__byteArraySize(aString) - nInstBytes) / 2;

		if (i2 < n) {
		    union {
			char b[2];
			unsigned short s;
		    } u;
		    int i;
		    XChar2b *cp2 = (XChar2b *)0;
		    int mustFree = 0;

		    cp += (i1 * 2);
		    if (l > 1000) l = 1000;

		    /*
		     * ST/X TwoByteStrings store the asciiValue in native byteOrder;
		     * X expects them MSB first
		     * convert as required
		     */

		    u.s = 0x1234;
		    if (u.b[0] != 0x12) {
			if (l <= NLOCALBUFFER) {
			    cp2 = xlatebuffer;
			} else {
			    cp2 = (XChar2b *)(malloc(l * 2));
			    mustFree = 1;
			}
			for (i=0; i<l; i++) {
			    cp2[i].byte1 = (((XChar2b *)cp)[i]).byte2;
			    cp2[i].byte2 = (((XChar2b *)cp)[i]).byte1;
			}
			cp = (char *) cp2;
		    }

		    if (opaque == true)
			XDrawImageString16(myDpy, win, gc, __intVal(x), __intVal(y), (XChar2b *)cp, l);
		    else
			XDrawString16(myDpy, win, gc, __intVal(x), __intVal(y), (XChar2b *)cp, l);

		    if (mustFree) {
			free(cp2);
		    }

		    RETURN ( self );
		}
	    }
	}
    }
#undef NLOCALBUFFER
#endif 
%}.
    "x/y not integer, badGC or drawable, or not a string"
    self primitiveFailed
!

displayString:aString x:x y:y in:aDrawableId with:aGCId opaque:opaque 
    "draw a string - if opaque is false, draw foreground only; otherwise, draw both
     foreground and background characters.
     If the coordinates are not integers, an error is triggered."

%{  /* NOCONTEXT */
#ifdef NOTDEF
    GC gc;
    Window win;
    unsigned char *cp;
    int n;
    OBJ cls;
#   define NLOCALBUFFER 200
    XChar2b xlatebuffer[NLOCALBUFFER];
    int nInstBytes;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __isNonNilObject(aString)
     && __bothSmallInteger(x, y)) {
	gc = _GCVal(aGCId);
	win = _WindowVal(aDrawableId);
	cls = __qClass(aString);

	cp = _stringVal(aString);

	if ((cls == @global(String)) || (cls == @global(Symbol))) {
	    n = _stringSize(aString);
	    if (n > 1000) n = 1000;
	    if (opaque == true)
		XDrawImageString(myDpy, win, gc, __intVal(x), __intVal(y), (char *)cp, n);
	    else
		XDrawString(myDpy, win, gc, __intVal(x), __intVal(y), (char *)cp, n);
	    RETURN ( self );
	}

	nInstBytes = __OBJS2BYTES__(__intVal(__ClassInstPtr(cls)->c_ninstvars));
	cp += nInstBytes;

	if (__isBytes(aString)) {
	    n = __byteArraySize(aString) - nInstBytes - 1;

	    if (n > 1000) n = 1000;
	    if (opaque == true)
		XDrawImageString(myDpy, win, gc, __intVal(x), __intVal(y), (char *)cp, n);
	    else
		XDrawString(myDpy, win, gc, __intVal(x), __intVal(y), (char *)cp, n);
	    RETURN ( self );
	}

	/* TWOBYTESTRINGS */
	if (__isWords(aString)) {
	    union {
		char b[2];
		unsigned short s;
	    } u;
	    int i;
	    XChar2b *cp2;
	    int mustFree = 0;

	    n = (__byteArraySize(aString) - nInstBytes) / 2;
	    if (n > 1000) n = 1000;

	    /*
	     * ST/X TwoByteStrings store the asciiValue in native byteOrder;
	     * X expects them MSB first
	     * convert as required
	     */

	    u.s = 0x1234;
	    if (u.b[0] != 0x12) {
		if (n <= NLOCALBUFFER) {
		    cp2 = xlatebuffer;
		} else {
		    cp2 = (XChar2b *)(malloc(n * 2));
		    mustFree = 1;
		}

		for (i=0; i<n; i++) {
		    cp2[i].byte1 = (((XChar2b *)cp)[i]).byte2;
		    cp2[i].byte2 = (((XChar2b *)cp)[i]).byte1;
		}
		cp = (char *) cp2;
	    }

	    if (opaque == true)
		XDrawImageString16(myDpy, win, gc, __intVal(x), __intVal(y), (XChar2b *)cp, n);
	    else
		XDrawString16(myDpy, win, gc, __intVal(x), __intVal(y), (XChar2b *)cp, n);


	    if (mustFree) {
		free(cp2);
	    }

	    RETURN ( self );
	}
    }
#undef NLOCALBUFFER
#endif
%}.
    "x/y not integer, badGC or drawable, or not a string"
    self primitiveFailed
!

drawBits:imageBits bitsPerPixel:bitsPerPixel depth:imageDepth 
			  width:imageWidth height:imageHeight 
			      x:srcx y:srcy
			   into:aDrawableId 
			      x:dstx y:dsty 
			  width:w height:h 
			   with:aGCId

    "draw a bitImage which has depth id, width iw and height ih into
     the drawable. draw a region of w/h pixels from srcx/srcy to dstx/dsty.
     Individual source pixels have bitsPerPixel bits, allowing to draw
     depth and pixel-units to be different.
     It has to be checked elsewhere, that the server can do it with the given
     depth - otherwise, primitive failure will be signalled.
     Also it is assumed, that the colormap is setup correctly and the
     colors are allocated - otherwise the colors may be wrong."

    "
     sorry; I had to separate it into 2 methods, since XPutImage needs
     an unlimited stack, and thus cannot send primitiveFailed
    "
    (self primDrawBits:imageBits bitsPerPixel:bitsPerPixel depth:imageDepth 
					width:imageWidth height:imageHeight 
					     x:srcx y:srcy
					  into:aDrawableId 
					     x:dstx y:dsty 
					 width:w height:h 
					  with:aGCId)
    ifFalse:[
	"
	 also happens, if a segmentation violation occurs in the 
	 XPutImage ...
	"
	self primitiveFailed
    ].
!

drawBits:imageBits depth:imageDepth 
		   width:imageWidth height:imageHeight 
		       x:srcx y:srcy
		    into:aDrawableId 
		       x:dstx y:dsty 
		   width:w height:h 
		    with:aGCId

    "draw a bitImage which has depth id, width iw and height ih into
     the drawable. draw a region of w/h pixels from srcx/srcy to dstx/dsty.
     Individual source pixels must have imageDepth bits.
     It has to be checked elsewhere, that the server can do it with the given
     depth - otherwise, primitive failure will be signalled.
     Also it is assumed, that the colormap is setup correctly and the
     colors are allocated - otherwise the colors may be wrong."

    ^ self drawBits:imageBits bitsPerPixel:imageDepth depth:imageDepth 
				     width:imageWidth height:imageHeight 
					 x:srcx y:srcy
				      into:aDrawableId 
					 x:dstx y:dsty 
				     width:w height:h 
				      with:aGCId

!

fillArcX:x y:y width:width height:height from:startAngle angle:angle
	       in:aDrawableId with:aGCId
    "fill an arc. If any coordinate is not integer, an error is triggered.
     The angles may be floats or integer - they are given in degrees."

%{  /* NOCONTEXT */

    int w, h, angle1, angle2;
    double f;

    if (__isSmallInteger(startAngle))
	angle1 = __intVal(startAngle) * 64;
    else if (__isFloat(startAngle)) {
	f = __floatVal(startAngle);
	angle1 = f * 64;
    }
    if (__isSmallInteger(angle))
	angle2 = __intVal(angle) * 64;
    else if (__isFloat(angle)) {
	f = __floatVal(angle);
	angle2 = f * 64;
    }
    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
	w = __intVal(width);
	h = __intVal(height);
	/*
	 * need this check here: some servers simply dump core with bad args
	 */
	if ((w >= 0) && (h >= 0) && (angle1 >= 0) && (angle2 >= 0)) {
	}
	RETURN ( self );
    }
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

fillPolygon:aPolygon in:aDrawableId with:aGCId
    "fill a polygon given by its points. 
     If any coordinate is not integer, an error is triggered."

    |numberOfPoints|

    numberOfPoints := aPolygon size.
%{
    OBJ point, x, y;
    int i, num;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __isSmallInteger(numberOfPoints)) {
	num = __intVal(numberOfPoints);
	if (num < 3) {
	    RETURN ( self );
	}
	for (i=0; i<num; i++) {
	    point = __AT_(aPolygon COMMA_CON, __MKSMALLINT(i+1));
	    if (! __isPoint(point)) goto fail;
	    x = _point_X(point);
	    y = _point_Y(point);
	    if (! __bothSmallInteger(x, y))
		goto fail;
	}
	RETURN ( self );

fail: ;
    }
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

fillRectangleX:x y:y width:width height:height in:aDrawableId with:aGCId
    "fill a rectangle. If any coordinate is not integer, an error is triggered."

%{  /* NOCONTEXT */

    int w, h;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
	w = __intVal(width);
	h = __intVal(height);
	/*
	 * need this check here: some servers simply dump core with bad args
	 */
	if ((w >= 0) && (h >= 0)) {
	}
	RETURN ( self );
    }
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

primDrawBits:imageBits bitsPerPixel:bitsPerPixel depth:imageDepth 
			      width:imageWidth height:imageHeight 
				  x:srcx y:srcy
			       into:aDrawableId 
				  x:dstx y:dsty 
			      width:w height:h 
			       with:aGCId

    "since XPutImage may allocate huge amount of stack space 
     (some implementations use alloca), this must run with unlimited stack."

%{  /* UNLIMITEDSTACK */


fail: ;
%}
.
    ^ false
! !

!WinWorkstation methodsFor:'event handling'!

dispatchEventFor:aViewIdOrNil withMask:eventMask
    "central event handling method:
     get next event and send appropriate message to the sensor or view.
     If the argument aViewIdOrNil is nil, events for any view are processed,
     otherwise only events for the view with given id are processed.
     If the argument aMask is nonNil, only events for this eventMask are
     handled."

    (self getEventFor:aViewIdOrNil withMask:eventMask) ifTrue:[
	AbortSignal catch:[
	    self dispatchLastEvent.
	]
    ].
!

dispatchExposeEventFor:aViewIdOrNil
    "get next expose event and send appropriate message to the sensor or view.
     If the argument aViewIdOrNil is nil, events for any view are processed,
     otherwise only events for the view with given id are processed."

    self dispatchEventFor:aViewIdOrNil withMask:(self eventMaskFor:#expose)
!

dispatchLastEvent
    |theView symS arg butt sibling windowID siblingID propertyID selectionID targetID requestorID
     eventType|

%{  /* STACK: 8000 */
%}.
    ^ true
!

dispatchPendingEvents
    "central event handling method for modal operation.
     (i.e. this is now only used in the modal debugger)
     This code is somewhat special, since X has a concept of graphic
     expose events (which are sent after a bitblt). After such a bitblt,
     we only handle exposes until the graphicsExpose arrives.
     Other systems may not need such a kludge"

    "interested in exposes only ?"
    dispatchingExpose notNil ifTrue:[
	[self exposeEventPendingFor:dispatchingExpose withSync:false] whileTrue:[
	    self dispatchExposeEventFor:dispatchingExpose
	].
	^ self
    ].

    "no, general dispatch"
    [self eventPendingWithSync:false] whileTrue:[
	self dispatchEventFor:nil withMask:nil
    ]
!

disposeEventsWithMask:aMask for:aWindowIdOrNil
    "dispose (throw away) specific events. If aWindowId is nil,
     events matching the mask are thrown away regardless of which
     view they are for. Otherwise, only matching events for that 
     view are flushed."

%{  /* NOCONTEXT */

%}.
    self primitiveFailed
!

eventMaskFor:anEventSymbol
    "return the eventMask bit-constant corresponding to an event symbol"

%{  /* NOCONTEXT */

    int m = 0;

#ifdef NOTDEF
    if (anEventSymbol == @symbol(keyPress)) m = KeyPressMask;
    else if (anEventSymbol == @symbol(keyRelease)) m = KeyReleaseMask;
    else if (anEventSymbol == @symbol(buttonPress)) m = ButtonPressMask;
    else if (anEventSymbol == @symbol(buttonRelease)) m = ButtonReleaseMask;
    else if (anEventSymbol == @symbol(buttonMotion)) m = ButtonMotionMask;
    else if (anEventSymbol == @symbol(pointerMotion)) m = PointerMotionMask;
    else if (anEventSymbol == @symbol(expose)) m = ExposureMask;
    else if (anEventSymbol == @symbol(focusChange)) m = FocusChangeMask;
    else if (anEventSymbol == @symbol(enter)) m = EnterWindowMask;
    else if (anEventSymbol == @symbol(leave)) m = LeaveWindowMask;
    else if (anEventSymbol == @symbol(keymapState)) m = KeymapStateMask;
    else if (anEventSymbol == @symbol(visibilityChange)) m = VisibilityChangeMask;
    else if (anEventSymbol == @symbol(structureNotify)) m = StructureNotifyMask;
    else if (anEventSymbol == @symbol(resizeRedirect)) m = ResizeRedirectMask;
    else if (anEventSymbol == @symbol(propertyChange)) m = PropertyChangeMask;
    else if (anEventSymbol == @symbol(colormapChange)) m = ColormapChangeMask;
#endif
    RETURN (__MKSMALLINT(m));
%}
!

eventPending
    "return true, if any event is pending. 
     This looks for both the internal queue and the display connection."

    ConservativeSyncing == true ifTrue:[self sync].

    dispatchingExpose notNil ifTrue:[
	^ self exposeEventPendingFor:dispatchingExpose withSync:false
    ].
    ^ self eventPendingWithSync:false
!

eventPending:anEventSymbol for:aWindowIdOrNil
    "return true, if a specific event is pending"

    ^ self eventsPending:(self eventMaskFor:anEventSymbol) for:aWindowIdOrNil withSync:false
!

eventPendingWithSync:doSync
    "return true, if any event is pending. 
     If doSync is true, do a sync output buffer (i.e. send all to the display and wait until its processed)
     before checking."

%{  /* UNLIMITEDSTACK */

    RETURN ( false );
%}
!

eventQueued
    "return true, if any event is queued"

    dispatchingExpose notNil ifTrue:[
	^ self exposeEventPendingFor:dispatchingExpose withSync:false
    ].
    ^ self eventQueuedAlready

    "Created: 12.12.1995 / 21:43:00 / stefan"
!

eventQueuedAlready
    "return true, if any event is queued internally.
     (i.e. in X's internal event queue, which is both filled by explicit
      nextEvent calls AND whenever drawing is done and events are pending on
      the display connection)."

%{  /* UNLIMITEDSTACK */

    RETURN ( false );
%}
!

eventsPending:anEventMask for:aWindowIdOrNil withSync:doSync
    "return true, if any of the masked events is pending"

%{  /* UNLIMITEDSTACK */

    RETURN ( false );
%}
!

exposeEventPendingFor:aWindowIdOrNil withSync:doSync
    "return true, if any expose event is pending for a specific view,
     or any view (if the arg is nil).
     This is an X specific, only required after a scroll operation."

%{  /* UNLIMITEDSTACK */

    RETURN ( false );
%}
!

getEventFor:aViewIdOrNil withMask:eventMask
    "read next event - put into local eventBuffer. 
     If aViewIdOrNil is nil, events for any view are fetched; 
     otherwise only events for that specific view will be fetched.
     Returns true, if there was an event, false otherwise.
     This method may block - so you better check for pending events
     before calling for it.

     Sorry I had to split dispatch into this fetch method and an extra
     handle method to allow unlimitedstack here.
     (some Xlibs do a big alloca there ...) which cannot be done in 
     dispatchLastEvent, since it dispatches out into ST-methods.
     BUG: uses a static buffer - has to be rewritten, to support multiple
     display connections.
    "

%{  /* UNLIMITEDSTACK */

%}.
    ^ false
!

handleAllEvents
    "from now on, handle any kind of event"

    dispatchingExpose := nil
!

handleExposeOnlyFor:aView
    "from now on, handle expose events only"

    dispatchingExpose := aView id
!

mappingChanged:what event:eB
    "One of Keyboard-, Modifier- or PointerMap has change, probably by xmodmap.
     Tell xlib about the fact."

    (what == #mappingKeyboard or:[what == #mappingModifier]) ifTrue:[
	self refreshKeyboardMapping:eB.
	"Maybe some of our modifiers have been changed"
	self initializeModifierMappings.
    ].

    "Created: 1.12.1995 / 16:28:23 / stefan"
!

setEventMask:aMask in:aWindowId
    "tell X that we are only interested in events from aMask, which
     is the bitwise or of the eventMask bits (see 'eventMaskFor:')"

    ^ self
!

startDispatch
    "redefined to clear dispatchingExpose, which is a special X feature"

    dispatching ifTrue:[^ self].
    dispatchingExpose := nil.
    super startDispatch
! !

!WinWorkstation methodsFor:'event sending'!

sendKeyOrButtonEvent:typeSymbol x:xPos y:yPos keyOrButton:keySymCodeOrButtonNr state:stateMask toViewId:targetId
    "send a keyPress/Release or buttonPress/Release event to some (possibly alien) view.
     TypeSymbol must be one of: #keyPress, #keyRelease, #buttonPress , #buttonRelease.
     For buttonEvents, the keySymCodeOrButtonNr must be the buttons number (1, 2 ...);
     for key events, it can be either a symbol (as listen in X's keySyms)
     or a numeric keysym code. If state is nil, the modifier bits (shift & control)
     are computed from the keyboardMap - if non-nil, these are passed as modifierbits.
     The non-nil case is the lowlevel entry, where state must include any shift/ctrl information
     (not very user friendly)"

    ^ false
!

simulateKeyboardInput:aCharacterOrString inViewId:viewId
    "send input to some other view, by simulating keyPress/keyRelease
     events. 
     Only a few control characters are supported.
     Notice: not all alien views allow this kind of synthetic input;
	     some simply ignore it."

    |control code state|

    aCharacterOrString isString ifTrue:[
	aCharacterOrString do:[:char |
	    self simulateKeyboardInput:char inViewId:viewId
	].
	^ self
    ].

    control := false.
    code := aCharacterOrString asciiValue.

    (aCharacterOrString == Character cr) ifTrue:[
	code := #Return
    ] ifFalse:[
	(aCharacterOrString == Character tab) ifTrue:[
	    code := #Tab 
	] ifFalse:[
	    (aCharacterOrString == Character esc) ifTrue:[
		code := #Escape 
	    ]
	]
    ].

    control ifTrue:[
	state := self controlMask
    ].


    "/ the stuff below should not be needed 
    "/ (sendKeyOrButtonevent should be able to figure out things itself)
    "/ however, on some linux systems it seems to not work correctly.
    "/ Hopefully, this is correct ...

    code isNumber ifTrue:[
	code >= $A asciiValue ifTrue:[
	    code <= $Z asciiValue ifTrue:[
		state := self shiftMask
	    ]
	]
    ].

    self sendKeyOrButtonEvent:#keyPress x:0 y:0 keyOrButton:code state:state toViewId:viewId.
    self sendKeyOrButtonEvent:#keyRelease x:0 y:0 keyOrButton:code state:state toViewId:viewId

    "
      sending input to some (possibly alien) view:

      |point id|

      point :=  Display pointFromUser.
      id := Display viewIdFromPoint:point.
      Display simulateKeyboardInput:'Hello_world' inViewId:id
    "

    "Modified: 11.6.1996 / 10:59:42 / cg"
! !

!WinWorkstation methodsFor:'font stuff'!

ascentOf:aFontId
    "the normal ascent"

%{  /* NOCONTEXT */

%}.
    ^ nil
!

createFontFor:aFontName
    "a basic method for font allocation; this method allows
     any font to be aquired (even those not conforming to
     standard naming conventions, such as cursor, fixed or k14)"

%{
    HGDIOBJ hFont;
    char *fn;

    if (__isString(aFontName)) {
	fn = __stringVal(aFontName);
	if (strcmp(fn, "fixed") == 0) {
	    hFont = GetStockObject(ANSI_FIXED_FONT);
	} else if (strcmp(fn, "variable") == 0) {
	    hFont = GetStockObject(ANSI_VAR_FONT);
	} else {
	    hFont = (HGDIOBJ)0;
	    hFont = GetStockObject(ANSI_FIXED_FONT);
	}
	if (hFont) {
	    RETURN ( __MKOBJ(hFont) );
	}
    }
%}.
    ^ nil
!

descentOf:aFontId
    "the normal descent"

    ^ nil
!

encodingOf:aFontId
    "the fonts encoding - if the font does not provide that info,
     return nil (and assume #ascii, which is a subset of #iso8859)."

    ^ #iso8859
!

fontMetricsOf:fontId into:aBlock
    "evaluate aBlock, passing a fonts metrics as arguments"

    |encoding avgAscent avgDescent
     maxAscent maxDescent minWidth maxWidth avgWidth|

%{
    HGDIOBJ hFont;
    TEXTMETRIC tmet;
    int len;

    if (ISCONNECTED) {
        if (__isExternalAddress(fontId)) {
            hFont = _HGDIOBJVal(fontId);
	    GetTextMetrics(hFont, &tmet);

            avgAscent = __MKSMALLINT(tmet.tmAscent);
            avgDescent = __MKSMALLINT(tmet.tmDescent);
            maxAscent = __MKSMALLINT(tmet.tmAscent);
            maxDescent = __MKSMALLINT(tmet.tmDescent);
            minWidth = __MKSMALLINT(tmet.tmAveCharWidth);
            maxWidth = __MKSMALLINT(tmet.tmMaxCharWidth);
	    avgWidth = __MKSMALLINT(tmet.tmAveCharWidth);
        }
    }
%}.
    encoding := self encodingOf:fontId.
    aBlock value:encoding
           value:avgAscent
           value:avgDescent
           value:maxAscent
           value:maxDescent
           value:minWidth
           value:maxWidth
           value:avgWidth
!

fullNameOf:aFontId
    "the fonts fullName - this is very device specific and should only be
     used for user feed-back (for example: in the fontPanel).
     If the display/font do not provide that info, return nil."

    ^ nil
!

getAvailableFontsMatching:pattern
    "return an Array filled with font names matching aPattern"

    ^ nil
!

getDefaultFont
    "return a default font id - used when class Font cannot
     find anything usable"

     ^ self createFontFor:'fixed'
!

getFontWithFamily:familyString face:faceString
	    style:styleArgString size:sizeArg encoding:encodingSym

    "try to get the specified font, if not available, try next smaller
     font. Access to X-fonts by name is possible, by passing the X font name
     as family and the other parameters as nil. For example, the cursor font
     can be aquired that way."

    |styleString theName theId xlatedStyle id spacing|

    styleString := styleArgString.

    "special: if face is nil, allow access to X-fonts"
    faceString isNil ifTrue:[
	sizeArg notNil ifTrue:[
	    theName := familyString , '-' , sizeArg printString
	] ifFalse:[
	    theName := familyString
	].
	theName isNil ifTrue:[
	    "
	     mhmh - fall back to the default font
	    "
	    theName := 'fixed'
	].
	theId := self createFontFor:theName.
	theId isNil ifTrue:[
	    theId := self getDefaultFont
	].
	^ theId
    ].

    "/ spacing other than 'normal' is contained as last component
    "/ in style

    ((styleString endsWith:'-narrow') 
     or:[styleString endsWith:'-semicondensed']) ifTrue:[
	|i|
	i := styleString lastIndexOf:$-.
	spacing := styleString copyFrom:(i+1).
	styleString := styleString copyTo:(i-1).
    ] ifFalse:[
	spacing := 'normal'.
    ].

    xlatedStyle := styleString.
    xlatedStyle notNil ifTrue:[
	xlatedStyle := xlatedStyle first asString
    ].

    id := self 
	    getFontWithFoundry:'*'
	    family:familyString asLowercase
	    weight:faceString
	    slant:xlatedStyle
	    spacing:spacing
	    pixelSize:nil
	    size:sizeArg 
	    registry:encodingSym
	    encoding:'*'.

    id isNil ifTrue:[
	(encodingSym notNil and:[encodingSym ~= '*']) ifTrue:[
	    "/ too stupid: encodings come in both cases
	    "/ and X does not ignore case
	    "/
	    id := self 
		    getFontWithFoundry:'*'
		    family:familyString asLowercase
		    weight:faceString
		    slant:xlatedStyle
		    spacing:spacing
		    pixelSize:nil
		    size:sizeArg 
		    registry:encodingSym asUppercase
		    encoding:'*'.
	    id isNil ifTrue:[
		id := self 
			getFontWithFoundry:'*'
			family:familyString asLowercase
			weight:faceString
			slant:xlatedStyle
			spacing:spacing
			pixelSize:nil
			size:sizeArg 
			registry:encodingSym asLowercase
			encoding:'*'.
	    ]
	]
    ].
    ^ id

    "Modified: 24.2.1996 / 22:37:24 / cg"
    "Modified: 4.7.1996 / 11:38:47 / stefan"
!

getFontWithFoundry:foundry family:family weight:weight
	      slant:slant spacing:spc pixelSize:pSize size:size 
	      registry:registry encoding:encoding

    "get the specified font, if not available, return nil.
     This is the new font creation method - all others will be changed to
     use this entry.
     Individual attributes can be left empty (i.e. '') or nil to match any.

     foundry: 'adobe', 'misc', 'dec', 'schumacher' ... usually '*'
     family:  'helvetica' 'courier' 'times' ...
     weight:  'bold' 'medium' 'demi' ...
     slant:   'r(oman)' 'i(talic)' 'o(blique)'
     spacing: 'narrow' 'normal' semicondensed' ... usually '*'
     pixelSize: 16,18 ... usually left empty
     size:      size in point (1/72th of an inch)
     registry:  iso8859, sgi ... '*'
     encoding:  vendor specific encoding (usually '*')
    "

    |theName sizeMatch 
     foundryMatch familyMatch weightMatch slantMatch spcMatch
     pSizeMatch registryMatch encodingMatch
     id|

    "this works only on 'Release >= 3' - X-servers"
    "name is:
	-foundry-family    -weight -slant-
	 sony    helvetica bold     r
	 adobe   courier   medium   i
	 msic    fixed              o
	 ...     ...
    "

    size isNil ifTrue:[
	sizeMatch := '*'
    ] ifFalse:[
	sizeMatch := size printString , '0'
    ].
    foundry isNil ifTrue:[
	foundryMatch := '*'
    ] ifFalse:[
	foundryMatch := foundry
    ].
    family isNil ifTrue:[
	familyMatch := '*'
    ] ifFalse:[
	familyMatch := family
    ].
    weight isNil ifTrue:[
	weightMatch := '*'
    ] ifFalse:[
	weightMatch := weight
    ].
    slant isNil ifTrue:[
	slantMatch := '*'
    ] ifFalse:[
	slantMatch := slant
    ].
    spc isNil ifTrue:[
	spcMatch := '*'
    ] ifFalse:[
	spcMatch := spc
    ].
    pSize isNil ifTrue:[
	pSizeMatch := '*'
    ] ifFalse:[
	pSizeMatch := pSize printString
    ].
    registry isNil ifTrue:[
	registryMatch := '*'
    ] ifFalse:[
	registryMatch := registry
    ].
    encoding isNil ifTrue:[
	encodingMatch := '*'
    ] ifFalse:[
	encodingMatch := encoding
    ].

    theName := ('-' , foundryMatch,
		'-' , familyMatch,
		'-' , weightMatch ,
		'-' , slantMatch , 
		'-' , spcMatch ,
		'-*' ,
		'-' , pSizeMatch ,
		'-' , sizeMatch ,
		'-*-*-*-*' ,
		'-' , registryMatch ,
		'-' , encodingMatch).

"/  Transcript showCR:theName; endEntry.

    ^ self createFontFor:theName.

    "
     Display getFontWithFoundry:'*'
			 family:'courier'
			 weight:'medium'
			  slant:'r'
			spacing:nil
		      pixelSize:nil
			   size:13
		       registry:'iso8859'
		       encoding:'*'
    "

    "Modified: 24.2.1996 / 22:33:29 / cg"
!

listOfAvailableFonts
    "return a list with all available fonts on this display.
     Since this takes a long time, keep the result of the query for the
     next time. The elements of the returned collection are instances of
     FontDescription."

    ^ listOfFonts

    "
     Display listOfAvailableFonts.

     Display getAvailableFontsMatching:'*'.
    "

    "Modified: 27.9.1995 / 10:54:47 / stefan"
    "Modified: 17.4.1996 / 15:27:57 / cg"
!

maxAscentOf:aFontId
    "the max ascent"

    ^ nil
!

maxDescentOf:aFontId
    "the max descent"

    ^ nil
!

maxWidthOfFont:aFontId
    "the width of the widest character"

    ^ nil
!

minWidthOfFont:aFontId

    ^ nil
!

releaseFont:aFontId

    ^ self
!

sizesInFamily:aFamilyName face:aFaceName style:aStyleName filtering:filter
    "return a set of all available font sizes in aFamily/aFace/aStyle
     on this display.
     Redefined to handle X's special case of 0-size (which stands for any)"

    |sizes|

    sizes := super sizesInFamily:aFamilyName face:aFaceName style:aStyleName filtering:filter.
    (sizes notNil and:[sizes includes:0]) ifTrue:[
	"special: in X11R5 and above, size 0 means:
	 there are scaled versions in all sizes available"

	^ #(4 5 6 7 8 9 10 11 12 14 16 18 20 22 24 28 32 48 64)
    ].
    ^ sizes

    "
     Display sizesInFamily:'courier' face:'bold' style:'roman'
    "

    "Created: 27.2.1996 / 01:38:15 / cg"
!

widthOf:aString from:index1 to:index2 inFont:aFontId

%{  /* NOCONTEXT */
#ifdef NOTDEF
    XFontStruct *f;
    char *cp;
    int len, n, i1, i2, l;
    OBJ cls;
#   define NLOCALBUFFER 200
    XChar2b xlatebuffer[NLOCALBUFFER];
    int nInstBytes;

    if (ISCONNECTED) {
	if (__bothSmallInteger(index1, index2)
	 && __isExternalAddress(aFontId)
	 && __isNonNilObject(aString)) {
	    f = _FontVal(aFontId);
	    i1 = __intVal(index1) - 1;
	    cls = __qClass(aString);

	    if (i1 >= 0) {
		i2 = __intVal(index2) - 1;
		if (i2 < i1) {
		    RETURN (self);
		}

		cp = (char *) _stringVal(aString);
		l = i2 - i1 + 1;

		if ((cls == @global(String)) || (cls == @global(Symbol))) {
		    n = _stringSize(aString);
		    if (i2 < n) {
			cp += i1;
			BEGIN_INTERRUPTSBLOCKED
			len = XTextWidth(f, cp, l);
			END_INTERRUPTSBLOCKED
			RETURN ( __MKSMALLINT(len) );
		    }
		}

		nInstBytes = __OBJS2BYTES__(__intVal(__ClassInstPtr(cls)->c_ninstvars));
		cp += nInstBytes;

		if (__isBytes(aString)) {
		    n = __byteArraySize(aString) - nInstBytes;
		    if (i2 < n) {
			cp += i1;
			BEGIN_INTERRUPTSBLOCKED
			len = XTextWidth(f, cp, l);
			END_INTERRUPTSBLOCKED
			RETURN ( __MKSMALLINT(len) );
		    }
		}

		/* TWOBYTESTRINGS */
		if (__isWords(aString)) {
		    n = (__byteArraySize(aString) - nInstBytes) / 2;

		    if (i2 < n) {
			union {
			    char b[2];
			    unsigned short s;
			} u;
			int i;
			XChar2b *cp2 = (XChar2b *)0;
			int mustFree = 0;

			cp += (i1 * 2);
			if (l > 1000) l = 1000;

			/*
			 * ST/X TwoByteStrings store the asciiValue in native byteOrder;
			 * X expects them MSB first
			 * convert as required
			 */

			u.s = 0x1234;
			if (u.b[0] != 0x12) {
			    if (l <= NLOCALBUFFER) {
				cp2 = xlatebuffer;
			    } else {
				cp2 = (XChar2b *)(malloc(l * 2));
				mustFree = 1;
			    }
			    for (i=0; i<l; i++) {
				cp2[i].byte1 = (((XChar2b *)cp)[i]).byte2;
				cp2[i].byte2 = (((XChar2b *)cp)[i]).byte1;
			    }
			    cp = (char *) cp2;
			}
			BEGIN_INTERRUPTSBLOCKED
			len = XTextWidth16(f, (XChar2b *)cp, l);
			END_INTERRUPTSBLOCKED

			if (mustFree) {
			    free(cp2);
			}

			RETURN ( __MKSMALLINT(len) );
		    }
		}
	    }
	}
    }
#undef NLOCALBUFFER
#endif
%}.
    self primitiveFailed.
    ^ nil
!

widthOf:aString inFont:aFontId

%{  /* NOCONTEXT */
#ifdef NOTDEF
    XFontStruct *f;
    char *cp;
    int len, n;
    OBJ cls;
#   define NLOCALBUFFER 200
    XChar2b xlatebuffer[NLOCALBUFFER];
    int nInstBytes;

    if (ISCONNECTED) {
	if (__isExternalAddress(aFontId)
	 && __isNonNilObject(aString)) {
	    f = _FontVal(aFontId);
	    cls = __qClass(aString);

	    cp = (char *)_stringVal(aString);

	    if ((cls == @global(String)) || (cls == @global(Symbol))) {
		n = _stringSize(aString);
		BEGIN_INTERRUPTSBLOCKED
		len = XTextWidth(f, cp, n);
		END_INTERRUPTSBLOCKED
		RETURN ( __MKSMALLINT(len) );
	    }

	    nInstBytes = __OBJS2BYTES__(__intVal(__ClassInstPtr(cls)->c_ninstvars));
	    cp += nInstBytes;

	    if (__isBytes(aString)) {
		n = __byteArraySize(aString) - nInstBytes;

		BEGIN_INTERRUPTSBLOCKED
		len = XTextWidth(f, cp, n);
		END_INTERRUPTSBLOCKED
		RETURN ( __MKSMALLINT(len) );
	    }

	    /* TWOBYTESTRINGS */
	    if (__isWords(aString)) {
		union {
		    char b[2];
		    unsigned short s;
		} u;
		int i;
		XChar2b *cp2;
		int mustFree = 0;

		n = (__byteArraySize(aString) - nInstBytes) / 2;
		if (n > 1000) n = 1000;

		/*
		 * ST/X TwoByteStrings store the asciiValue in native byteOrder;
		 * X expects them MSB first
		 * convert as required
		 */

		u.s = 0x1234;
		if (u.b[0] != 0x12) {
		    if (n <= NLOCALBUFFER) {
			cp2 = xlatebuffer;
		    } else {
			cp2 = (XChar2b *)(malloc(n * 2));
			mustFree = 1;
		    }

		    for (i=0; i<n; i++) {
			cp2[i].byte1 = (((XChar2b *)cp)[i]).byte2;
			cp2[i].byte2 = (((XChar2b *)cp)[i]).byte1;
		    }
		    cp = (char *) cp2;
		}

		BEGIN_INTERRUPTSBLOCKED
		len = XTextWidth16(f, (XChar2b *)cp, n);
		END_INTERRUPTSBLOCKED

		if (mustFree) {
		    free(cp2);
		}

		RETURN ( __MKSMALLINT(len) );
	    }
	}
    }
#undef NLOCALBUFFER
#endif
%}.
    self primitiveFailed.
    ^ nil
! !

!WinWorkstation methodsFor:'grabbing '!

allowEvents:mode
!

grabKeyboardIn:aWindowId
    "grab the keyboard"

!

grabPointerIn:aWindowId withCursor:aCursorId pointerMode:pMode keyboardMode:kMode confineTo:confineId
    "grap the pointer - return true if ok"

!

ungrabKeyboard
    "release the keyboard"

    activeKeyboardGrab := nil
!

ungrabPointer
    "release the pointer"

    activePointerGrab := nil
! !

!WinWorkstation methodsFor:'graphic context stuff'!

noClipIn:aGCId
    "disable clipping rectangle"

!

setBackground:bgColorIndex in:aGCId
    "set background color to be drawn with"

!

setBitmapMask:aBitmapId in:aGCId
    "set or clear the drawing mask - a bitmap mask using current fg/bg"

!

setClipByChildren:aBool in:aGCId
    "enable/disable drawing into child views"

!

setClipX:clipX y:clipY width:clipWidth height:clipHeight in:aGCId
    "clip to a rectangle"

!

setDashes:dashList dashOffset:offset in:aGCId
    "set line attributes"

!

setFont:aFontId in:aGCId
    "set font to be drawn in"

!

setForeground:fgColorIndex background:bgColorIndex in:aGCId
    "set foreground and background colors to be drawn with"

!

setForeground:fgColor background:bgColor mask:aBitmapId in:aGCId
    "set foreground and background colors to be drawn with using mask or
     solid (if aBitmapId is nil)"

!

setForeground:fgColor background:bgColor mask:aBitmapId lineWidth:lw in:aGCId
    "set foreground and background colors to be drawn with using mask or
     solid (if aBitmapId is nil); also set lineWidth"

!

setForeground:fgColorIndex in:aGCId
    "set foreground color to be drawn with"

!

setFunction:aFunctionSymbol in:aGCId
    "set alu function to be drawn with"

!

setGraphicsExposures:aBoolean in:aGCId
    "set or clear the graphics exposures flag"

!

setLineWidth:aNumber style:lineStyle cap:capStyle join:joinStyle in:aGCId
    "set line attributes"

!

setMaskOriginX:orgX y:orgY in:aGCid
    "set the mask origin"

!

setPixmapMask:aPixmapId in:aGCId
    "set or clear the drawing mask - a pixmap mask providing full color"

! !

!WinWorkstation methodsFor:'initialize / release'!

close
    "close down the connection to the X-server"

!

initializeDefaultValues
    buttonTranslation := ButtonTranslation.
    multiClickTimeDelta := MultiClickTimeDelta.

    self initializeModifierMappings
!

initializeEventBuffer
!

initializeFor:aDisplayName
    "initialize the receiver for a connection to an X-Server;
     the argument, aDisplayName may be nil (for the default server from
     DISPLAY-variable or command line argument) or the name of the server 
     as hostname:number"

%{
    int maxRGBDepth;
    int rgbRedMask, rgbGreenMask, rgbBlueMask;
    int rgbVisualID;
    int nvi, i;
    int shapeEventBase, shapeErrorBase;
    int shmEventBase, shmErrorBase;
    int faxEventBase, faxErrorBase;
    char *type, *nm;
    int dummy;
    OBJ dpyID;

    if (__INST(displayId) != nil) {
	/*
	 * already connected - you bad guy try to
	 * trick me manually ?
	 */
	RETURN ( self );
    }

    __INST(displayId) = __MKSMALLINT(1);

%}.

    dispatching := false.
    dispatchingExpose := false.
    isSlow := false.
    shiftDown := false.
    ctrlDown := false.
    metaDown := false.
    altDown := false.
    motionEventCompression := true.
    buttonsPressed := 0.

    self initializeScreenProperties.

    self initializeDefaultValues.
    self initializeEventBuffer.
    self initializeSpecialFlags.
    self initializeKeyboardMap.
!

initializeModifierMappings
    shiftModifiers := #(Shift_L Shift_R Shift).
    ctrlModifiers := #(Control_L Control_R Control).
    metaModifiers := #(Alt_L Meta_L Meta_R Meta).
    altModifiers := #(Alt_R Alt).
!

initializeScreenProperties
    super initializeScreenProperties.

%{  /* NOCONTEXT */

    int scr;
    int maxRGBDepth;
    int rgbRedMask, rgbGreenMask, rgbBlueMask;
    int nvi, i, val, capabilities, __depth;
    char *type, *nm;
    int dummy;
    int mask, shift, nBits;
    HWND _rootWin = NULL;
    RECT rect;
    HDC _rootDC;
    OBJ id;

    _rootWin = GetDesktopWindow();
    __INST(rootWin) = id = __MKOBJ(_rootWin); __STORE(self, id);

    _rootDC = CreateDC("DISPLAY", NULL, NULL, NULL);
    __INST(rootDC) = id = __MKOBJ(_rootDC); __STORE(self, id);

    GetWindowRect(_rootWin,&rect);
    __INST(width) = __MKSMALLINT(rect.right-rect.left);
    __INST(height) = __MKSMALLINT(rect.bottom-rect.top);

    __depth = GetDeviceCaps(_rootDC, BITSPIXEL);

    __INST(depth) = __MKSMALLINT(__depth);
    __INST(ncells) = __MKSMALLINT(1<<__depth);

    val = GetDeviceCaps(_rootDC, HORZSIZE);
    __INST(widthMM) = __MKSMALLINT(val);
    val = GetDeviceCaps(_rootDC, VERTSIZE);
    __INST(heightMM) = __MKSMALLINT(val);


    capabilities = GetDeviceCaps(_rootDC, RASTERCAPS);

    __INST(whitepixel) = __MKSMALLINT(RGB(0xFF, 0xFF, 0xFF));
    __INST(blackpixel) = __MKSMALLINT(RGB(0,0,0));

    if (! (capabilities & RC_PALETTE)) {
	DPRINTF(("no palette\n"));
	if (__depth == 1) {
	    __INST(visualType) = @symbol(GrayScale);
	    __INST(hasColors) = false;
	    __INST(hasGreyscales) = false;
	    __INST(monitorType) = @symbol(monochrome);
	} else {
	    __INST(visualType) = @symbol(StaticColor);
	    __INST(hasColors) = true;
	    __INST(hasGreyscales) = true;
	}
    } else {
	val = GetDeviceCaps(_rootDC, SIZEPALETTE); /* First two entries are black and white. */

	__INST(ncells) = __MKSMALLINT(val);
	__INST(blackpixel) = __MKSMALLINT(0);
	__INST(whitepixel) = __MKSMALLINT(1);
	__INST(hasColors) = true;
	__INST(hasGreyscales) = true;
    }      

    __INST(monitorType) = @symbol(unknown);

    __INST(redShift) = __MKSMALLINT(0);
    __INST(greenShift) = __MKSMALLINT(8);
    __INST(blueShift) = __MKSMALLINT(16);
    __INST(bitsRed) = __INST(bitsGreen) = __INST(bitsBlue) = __MKSMALLINT(8);

%}.
!

initializeSpecialFlags
    "perform additional special server implementation flags"
!

reinitialize
    rootWin := rootDC := nil.
    super reinitialize.
    dispatchingExpose := nil
! !

!WinWorkstation methodsFor:'keyboard mapping'!

altModifierMask
    "return the mask (in motionEvents) for the alt-key modifier.
     Notice: ST/X may use the left ALT key as CMD/Meta key,
     therefore return a variable here, which can be changed during startup."

    ^ 16

    "Created: 23.3.1996 / 12:43:22 / cg"
    "Modified: 23.3.1996 / 12:44:56 / cg"
!

metaModifierMask
    "return the mask (in motionEvents) for the meta-key modifier.
     Notice: ST/X may use the left ALT key as CMD/Meta key,
     therefore return a variable here, which can be changed during startup."

    ^ 32

    "Created: 23.3.1996 / 12:43:39 / cg"
    "Modified: 23.3.1996 / 12:45:09 / cg"
!

modifier1Mask
    "return the Xlib mask bit for the 1st modifier key.
     See comment in altModifierMask: / metaModifierMask: for what
     this could be used."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(Mod1Mask));
%}
!

modifier2Mask
    "return the Xlib mask bit for the 2nd modifier key.
     See comment in altModifierMask: / metaModifierMask: for what
     this could be used."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(Mod2Mask));
%}
!

modifierMapping
    "Get the Modifier Mapping.
     We return an array of arrays of keycodes"

    ^ nil
!

stringFromKeycode:code
    "Get a KeySymbol (a smalltalk symbol) from the keycode."

    ^ ''

    "
	Display stringFromKeycode:28
    "
! !

!WinWorkstation methodsFor:'misc'!

beep
    "output an audible beep or bell"

    self beep:50
!

beep:volumeInPercent
    "output an audible beep"
!

buffered
    "buffer drawing - do not send it immediately to the display.
     This is the default anyway.
     See #unBuffered for additional info."

    "
     Display buffered
    "
!

flush
    "send all buffered drawing to the display.
     This may be required to make certain, that all previous operations
     are really sent to the display before continuing. For example,
     after a cursor-change with a followup long computation.
     (otherwise, the cursor change request may still be in the output buffer)
     See also #sync, which even waits until the request has been processed."

!

refreshKeyboardMapping:eB
!

setInputFocusTo:aWindowId
    self setInputFocusTo:aWindowId revertTo:#root
!

setInputFocusTo:aWindowId revertTo:revertSymbol
    "set the focus to the view as defined by aWindowId.
     Passing nil set the focus to no window and lets the display discard all
     input until a new focus is set.
     RevertSymbol specifies what should happen if the view becomes invisible;
     passing one of #parent, #root or nil specifies that the focus should be
     given to the parent view, the root view or no view."

!

sync
    "send all buffered drawing to the display AND wait until the display
     has finished drawing it.
     This is almost never needed, except if you are about to read previously
     drawn pixels back from the display screen, or you want to wait for a beep
     to be finished. See also #flush."

!

unBuffered
    "make all drawing be sent immediately to the display.
     This makes all graphics synchronous and turns off any buffering
     (i.e. each individual draw-request is sent immediately without 
      packing multiple requests into a larger message buffer).
     Be prepared, that this slows down graphics considerably.
     However, it allows display errors to be handled immediately and
     may be useful if you get Xdisplay errors and want to find the request
     which was responsiblefor it. See also #buffered."

    "Display unbuffered"
! !

!WinWorkstation methodsFor:'pointer queries '!

anyButtonStateMask
    "return an integer for masking out any button from a
     buttonStates value."

    "/ should use ``Display buttonXMotionMask bitOr:....''

    ^ 256 + 512 + 1024

    "Modified: 23.3.1996 / 12:41:33 / cg"
    "Created: 23.3.1996 / 12:46:35 / cg"
!

buttonStates
    "return an integer representing the state of the pointer buttons;
     a one-bit in positions 0.. represent a pressed button.
     See the button1Mask/button2Mask/button3Mask,
     shiftMask/controlMask and modifierMask methods for the meaning of the bits."

    "
     Display buttonStates     
    "

    "is the control-key pressed ?

     Display buttonStates bitTest:(Display controlMask)    
    "

    "is the alt/meta-key pressed ?

     Display buttonStates bitTest:(Display altModifierMask)    
     Display buttonStates bitTest:(Display metaModifierMask)    
    "
!

leftButtonStateMask
    "return an integer for masking out the left button from a
     buttonStates value"

    "/ should use ``Display button1MotionMask''

    ^ 256

    "Modified: 23.3.1996 / 12:41:33 / cg"
!

middleButtonStateMask
    "return an integer for masking out the middle button from a
     buttonStates value"

    "/ should use ``Display button2MotionMask''

    ^ 512

    "Modified: 23.3.1996 / 12:41:43 / cg"
!

pointerPosition
    "return the current pointer position in root-window coordinates"

    |xpos ypos|

    ^ xpos @ ypos
!

rightButtonStateMask
    "return an integer for masking out the right button from a
     buttonStates value"

    "/ should use ``Display button3MotionMask''

    ^ 1024

    "Modified: 23.3.1996 / 12:41:52 / cg"
!

rootPositionOfLastEvent
    "return the position in root-window coordinates
     of the last button, key or pointer event"

    ^ eventRootX @ eventRootY
! !

!WinWorkstation methodsFor:'retrieving pixels'!

getBitsFrom:aDrawableId x:srcx y:srcy width:w height:h into:imageBits
    "get bits from a drawable into the imageBits. The storage for the bits
     must be big enough for the data to fit. If ok, returns an array with some
     info and the bits in imageBits. The info contains the depth, bitOrder and
     number of bytes per scanline. The number of bytes per scanline is not known
     in advance, since the X-server is free to return whatever it thinks is a good padding."

    |rawInfo info|

    ((w <= 0) or:[h <= 0]) ifTrue:[
	self primitiveFailed.
	^ nil
    ].

    rawInfo := Array new:8.
		  "1 -> bit order"
		  "2 -> depth"
		  "3 -> bytes_per_line"
		  "4 -> byte_order"
		  "5 -> format"
		  "6 -> bitmap_unit"
		  "7 -> bitmap_pad"
		  "8 -> bits_per_pixel"

    "/ had to extract the getPixel call into a separate method, to specify
    "/ unlimitedStack (some implementations use alloca and require huge amounts
    "/ of temporary stack space

    (self primGetBitsFrom:aDrawableId x:srcx y:srcy width:w height:h into:imageBits infoInto:rawInfo) ifTrue:[
	info := IdentityDictionary new.
	info at:#bitOrder put:(rawInfo at:1).
	info at:#depth put:(rawInfo at:2).
	info at:#bytesPerLine put:(rawInfo at:3).
	info at:#byteOrder put:(rawInfo at:4).
	info at:#format put:(rawInfo at:5).
	info at:#bitmapUnit put:(rawInfo at:6).
	info at:#bitmapPad put:(rawInfo at:7).
	info at:#bitsPerPixel put:(rawInfo at:8).
	^ info
    ].
    "
     some error occured - either args are not smallintegers, imageBits is not a ByteArray
     or is too small to hold the bits
    "
    ^ self primitiveFailed
!

getPixelX:x y:y from:aDrawableId
    "return the pixel value at x/y; coordinates start at 0/0 for the upper left.
     Nil is returned for invalid coordinates or if any other problem arises."

    ^ nil
!

primGetBitsFrom:aDrawableId x:srcx y:srcy width:w height:h into:imageBits infoInto:info
    "since XGetImage may allocate huge amount of stack space 
     (some implementations use alloca), this must run with unlimited stack."

    ^ false
! !

!WinWorkstation methodsFor:'window stuff'!

clearRectangleX:x y:y width:width height:height in:aWindowId
    "clear a rectangular area to viewbackground"

!

clearWindow:aWindowId
    "clear a window to viewbackground"

!

configureWindow:aWindowId sibling:siblingId stackMode:modeSymbol
    "configure stacking operation of aWindowId w.r.t siblingId"

!

lowerWindow:aWindowId
    "bring a window to back"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)) {
        HWND win = _HWNDVal(aWindowId);

        if (win) {
	    SetWindowPos(win, HWND_BOTTOM, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);

            BringWindowToTop(win);
        }
        RETURN ( self );
    }
%}.

!

mapView:aView id:aWindowId iconified:aBoolean atX:xPos y:yPos width:w height:h
    "make a window visible - either as icon or as a real view - needed for restart"

!

mapWindow:aWindowId
    "make a window visible"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)) {
	HWND win = _HWNDVal(aWindowId);

        if (win) {
            ShowWindow(win, SW_SHOW);
	}
        RETURN ( self );
    }
%}.
    self primitiveFailed
!

moveResizeWindow:aWindowId x:x y:y width:w height:h
    "move and resize a window"

!

moveWindow:aWindowId x:x y:y
    "move a window"

!

raiseWindow:aWindowId
    "bring a window to front"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)) {
        HWND win = _HWNDVal(aWindowId);

        if (win) {
	    SetWindowPos(win, HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
        }
        RETURN ( self );
    }
%}.
    self primitiveFailed

!

resizeWindow:aWindowId width:w height:h
    "resize a window"

!

setBackingStore:how in:aWindowId
    "turn on/off backing-store for a window"

!

setBitGravity:how in:aWindowId
    "set bit gravity for a window"

!

setCursor:aCursorId in:aWindowId
    "define a windows cursor"

!

setIconName:aString in:aWindowId
    "define a windows iconname"

!

setSaveUnder:yesOrNo in:aWindowId
    "turn on/off save-under for a window"

!

setTransient:aWindowId for:aMainWindowId
    "set aWindowId to be a transient of aMainWindow"

!

setWindowBackground:aColorIndex in:aWindowId
    "set the windows background color. This is the color with which
     the view is filled whenever exposed. Do not confuse this with
     the background drawing color, which is used with opaque drawing."

!

setWindowBackgroundPixmap:aPixmapId in:aWindowId
    "set the windows background pattern to be a form.
     This is the pattern with which the view is filled whenever exposed. 
     Do not confuse this with the background drawing color, which is used 
     with opaque drawing."

!

setWindowBorderColor:aColorIndex in:aWindowId
    "set the windows border color"

!

setWindowBorderPixmap:aPixmapId in:aWindowId
    "set the windows border pattern"

!

setWindowBorderWidth:aNumber in:aWindowId
    "set the windows border width"

!

setWindowClass:wClass name:wName in:aWindowId
    "define class and name of a window.
     This may be used by the window manager to
     select client specific resources."

!

setWindowGravity:how in:aWindowId
    "set window gravity for a window"

!

setWindowIcon:aForm in:aWindowId
    "define a bitmap to be used as icon"

!

setWindowIconWindow:aView in:aWindowId
    "define a window to be used as icon"

!

setWindowName:aString in:aWindowId
    "define a windows name"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)
     && (__isString(aString) || __isSymbol(aString))) {
    }
%}.
    self primitiveFailed
!

unmapWindow:aWindowId
    "make a window invisible"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)) {
        HWND win = _HWNDVal(aWindowId);

        if (win) {
            ShowWindow(win, SW_HIDE);
        }
        RETURN ( self );
    }
%}.
    self primitiveFailed
! !

!WinWorkstation  class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libview/Attic/WinWorkstat.st,v 1.11 1996-07-24 21:00:40 cg Exp $'
! !

WinWorkstation initialize!
